with Interfaces.C;
with Gwindows;                use GWindows;
with Gwindows.Message_boxes;  use Gwindows.Message_boxes;
with Ada.Characters.Latin_1;  use Ada.Characters.Latin_1;


procedure MyWinVer is

   pragma linker_options ("-mwindows", "MyWinVer.coff", "-s");
   type OSVERSIONINFO is
   record
      dwOSVersionInfoSize : Interfaces.C.unsigned_long;
      dwMajorVersion      : Interfaces.C.unsigned_long;
      dwMinorVersion      : Interfaces.C.unsigned_long;
      dwBuildNumber       : Interfaces.C.unsigned_long;
      dwPlatformId        : Interfaces.C.unsigned_long;
      szCSDVersion        : GString_C (0 .. 127);
   end record;
   
   type LPOSVERSIONINFO is access all OSVERSIONINFO;
   
   function GetVersionEx (lpVersionInformation : LPOSVERSIONINFO)
                          return Interfaces.C.int;
                          
   pragma Convention (C, OSVERSIONINFO);

   pragma Import (Stdcall, GetVersionEx, "GetVersionEx" & Character_Mode_Identifier);
   
   OVI      : aliased OSVERSIONINFO;
   LP_OVI   : LPOSVERSIONINFO := OVI'Access;
   Result   : Interfaces.C.int;
   use type Interfaces.C.unsigned_long;
begin
      LP_OVI.dwOSVersionInfoSize := OSVERSIONINFO'size / 8;
      Result := GetVersionEx (LP_OVI);
      message_box ("Version de Windows...",
                   "Rsultat de l'API GetVersionEx : " & Result'Img & LF &
                   "Taille en octets de la structure de donnes : " & LP_OVI.dwOSVersionInfoSize'img & LF &
                   "Numro de version majeur : " & LP_OVI.dwMajorVersion'img & LF &
                   "Numro de version mineur : " & LP_OVI.dwMinorVersion'img & LF &
                   "Numro de construction : " & LP_OVI.dwBuildNumber'img & LF &
                   "Identificateur de plate-forme : " & LP_OVI.dwPlatformId'img & LF &
                   "Commentaires de version : " & Interfaces.C.to_Ada(LP_OVI.szCSDVersion),
                   OK_Box,
                   Information_Icon);
end MyWinVer;